<?php

function signup_services_total_access($data) {
  return TRUE;
}


function signup_services_total($data){

  $query = db_select('signup_log');
  $query->condition('nid', $data['nid']);
  $count = $query->countQuery()->execute()->fetchField();

  return $count;
}


function signup_services_load_signup_access($data) {
  return TRUE;
}

/**
 * Action: Load signup data.
 */
function signup_services_load_signup($data) {

  $signup = db_query('SELECT sl.*, n.title, u.name, u.mail FROM {signup_log} sl INNER JOIN {node} n ON sl.nid = n.nid INNER JOIN {users} u ON sl.uid = u.uid WHERE sl.uid = :uid AND sl.nid = :nid', array(':uid' => $data['uid'], ':nid' => $data['nid']))->fetchObject();

  if (!empty($signup)) {
    return array('signup_loaded' => $signup);
    //return 'This user has signed up to this node';
  }
  return services_error(t('No one has signuped to this node'), 404);
}


/**
 * Action: Sign up a user to content.
 * $signup_form_data: Name, Phone, Num, etc. example(signup_form_data[Name])
 */
function signup_services_signup_user($data, $signup_form_data) {

  $result = db_query("SELECT uid FROM {signup_log} WHERE uid = :uid AND nid = :nid", array(':uid' => $data['uid'], ':nid' => $data['nid']))->fetchObject();
  // Check the node signup status before signing up the user.
  if (empty($result)) {
    signup_sign_up_user($data);

    return 'Sign Up Success';
  }
    return 'This user has already signed up to this node';
}



/**
 * Action: Cancel all signups for a node.
 */
function signup_services_cancel_node_signups($data) {
  $signups = signup_get_signups($data['nid']);
  foreach ($signups as $signup) {
    signup_cancel_signup($signup, FALSE);
  }
  return TRUE;
}


/**
 * Action: Cancel all signups for a user.
 */
function signup_services_cancel_user_signups($data) {
  $signups = signup_rules_get_user_signups($data['uid']);
  foreach ($signups as $signup) {
    signup_cancel_signup($signup, FALSE);
  }
  return TRUE;
}

/**
 * Action: Close signups for a node.
 *
 * The conditional checks to see if signups are even enabled for
 * the node type. If they aren't then there is no attempt to close
 * them as they should be closed by Signup already.
 */
function signup_services_close_signups($data) {
  if (variable_get('signup_node_default_state_'. $data['type'], 'disabled') != 'disabled') {
    signup_close_signup($data['nid']);

    return TRUE;
  }

  return FALSE;
}

/**
 * Action: Open signups for a node.
 *
 * The conditional checks to ensure that signups are enabled for
 * the node before programatically opening signups.
 */
function signup_services_open_signups($data) {
  if (variable_get('signup_node_default_state_'. $data['type'], 'disabled') != 'disabled') {
    signup_open_signup($data['nid']);

    return TRUE;
  }

  return FALSE;
}